/* Copyright (C) 1999 Dustin Ward <Vortex@qconline.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */  
#include "main.h"

const char *optstring = ":c:d:s:vfbho";

struct option options[] = { 
  {"command", required_argument, NULL, 'c'}, 
  {"device", required_argument, NULL, 'd'}, 
  {"server", required_argument, NULL, 's'}, 
  {"version", no_argument, NULL, 'v'}, 
  {"force", no_argument, NULL, 'f'}, 
  {"banner", no_argument, NULL, 'b'}, 
  {"help", no_argument, NULL, 'h'},
  {"output", no_argument, NULL, 'o'}, 
  {NULL, 0, NULL, 0} 
};
int
usage () 
{
  fprintf (output, "demcd v%s by dem (vortex@qconline.com\n" 
	    "demcd [args]\n" 
	    "      -v, --version : prints out version and exits\n" 
	    "      -f, --force   : open without checking for cd in cdrom\n" 
	    "      -b, --banner  : shuts startup banner off\n" 
	    "      -h, --help    : prints out this message\n" 
	    "      -o, --output  : outputs to stdout instead of stderr\n"
	    "      -c  <command>, --command : will run by command line\n" 
	    "      -d  <device>,  --device  : sets cdrom device ex: /dev/hdd\n"
	    "      -s  <server>,  --server  : sets cddb server\n", VER);
  exit (0);
}
void CLEAN()
{
   exit(0);
}
int cleanup()
{
   system("rm ~/.demcd/.demcdloop &>/dev/null");
   system("rm ~/.demcd/.demcdrand &>/dev/null");
   return 0;
}
int chdev(char *arg, int fd)
{
   if(!*arg)
     {
	printf("Need full path of device [/dev/cdrom]");
	return -1;
     }
   close(fd);
   strcpy(CD_DEV, arg);
         if ((fd = open (CD_DEV,  O_RDONLY | O_NONBLOCK)) == -1)
	{
	  myperror ("open()");
	  return 1;
	}
   if(cd_stat(fd, &disc)<0)
     {
	printf("open(): No medium found.\n"); 
	return 1;
     }
return 0;
}

int
main (int argc, char *argv[]) 
{
  DCD dcd;
  int a = 0;
  int f = 0;
  int g = 0;
  int c, long_option_index;
  lock=malloc(10);
  test = malloc (512);
  strcpy (CD_DEV, "/dev/cdrom");
  signal (SIGINT, eclean);
  signal (SIGBUS, eclean);
  signal (SIGQUIT, CLEAN);
  sigact.sa_handler = Seg;
  sigaction (SIGSEGV, &sigact, 0);
  sigaction (SIGFPE, &sigact, 0);
  sigaction (SIGILL, &sigact, 0);
  readrcconfig (LOCKED, dcd);
  buf = malloc (512);
  output=stderr;
  llock=LOCKED;
   cleanup(); // delete some demcd files
   while (
	  (c =
	   getopt_long (argc, argv, optstring, options,
			&long_option_index)) != EOF)
    {
      switch (c)
	
	{
	case 'v':
	  printf ("demcd v%s by dem (vortex@qconline.com)\n", VER);
	  return 0;
	  break;
	case 'o':
	  printf("Outputing to stdout.\n");
	  output=stdout;
	  break;
	case 'f':
	  fd = open (CD_DEV,  O_RDONLY | O_NONBLOCK);
	  f = 1;
	  break;
	case 'c':
	  g = 1;
	  strcpy (buf, optarg);
	  for (x = 0; x < argc; x++)
	    {
	      if (!strcmp (argv[x], optarg))
		{
		  x++;
		  if (argv[x])
		    {
		      strcpy (arg, argv[x]);
		    }
		  x++;
		   if(argv[x])
		     {
			strcpy (param, argv[x]);
		     }
		  x++;
		   
		}
	    }
	   sprintf(whole, "%s %s", arg, param);
	  break;
	case 's':
	  strcpy (CDDB_DEFAULT_HOSTNAME, optarg);
	  printf ("Using %s\n", optarg);
	  strcpy(dcd.serv[dcd.num].server, optarg);
	  writetocddb (DEFAULTTYPE, optarg, DEFAULTACCESS);
	  break;
	case 'b':
	  a = 1;
	  break;
	case 'h':
	  usage ();
	  break;
	case 'd':
	  printf ("Using %s\n", optarg);
	  strcpy (CD_DEV, optarg);
	  break;
	}
    }
  if (f != 1)
    {
       if ((fd = open (CD_DEV,  O_RDONLY | O_NONBLOCK)) == -1)
	{
	  myperror ("open()");
	  return 1;
	}
          if(cd_stat(fd, &disc)<0)
	 {
	            printf("open(): No medium found.\n");
	            return 1;
	 }
       
    }
  if (!strcasecmp (av, "-b"))
    
    {
      a = 1;
    }
  if(llock!=0)
  close (fd);
  if (a != 1)
    banner (g);
   for (;;)
    
    {
      
	if (g != 1)
	
	{
	  strcpy (arg, "");
	  strcpy (buf, "");
	  strcpy (param, "");
	  printf ("\n");
	  int_readline ();
	  getinput (buf, "demcd-> ");
   	  if (buf && *buf)
	    add_history (buf);
	   // No more space thinga majig
	    for (;;)
	    
	     {
	      if (isspace (*buf))
		
		{
		  buf++;
		}
	      
	      else
		
		{
		  break;
		}
	    }
	   nextword (buf, arg, param, whole);
	}
	   dcd.fd=fd;
	   dcd.argc=argc;
	   dcd.argv=argv;
	   dcd.arg=arg;
	   dcd.param=param;
           sprintf(whole, "%s %s", arg, param);
	   dcd.whole=whole;
	
      if(llock!=0)
      fd = open (CD_DEV,  O_RDONLY | O_NONBLOCK);
      execute_line (buf, &dcd);
      if(llock!=0)
      close (fd);
      if (g == 1)
	
	{
	  close (fd);
	  exit (0);
	}
    }
free(lock);
free(test);
free(buf);
}
char *
     dupstr (s)  char *
       s;

{
  char *r;
  r = xmalloc (strlen (s) + 1);
  strcpy (r, s);
  return (r);
}
char **
     demcd_completion (text, start, end)  char *
       text;
     int start, end;

{
  char **matches;
  matches = (char **) NULL;
  if (start == 0)
    matches = completion_matches (text, command_generator);
 if (start > 0)
     {
     matches = completion_matches (text, trkname_generator);
     }
return (matches);
}
int
int_readline () 
{
  rl_attempted_completion_function = (CPPFunction *) demcd_completion;
  return 0;
}
void
eclean () 
{
  cleanup();
  fprintf (output, "\nCaught signal, exited cleanly\n\n");
  exit (0);
}
void
Seg () 
{
   
   fprintf(output,
	   "\nYou found a BUG! See \'BUGS\' for details\n\n");
   kill(getpid(), SIGTERM);
}
int
banner (int g)
{
  if (g != 1)
    {
      
#ifdef OLDSTYLE
	printf ("   Welcome to demcd v%s running on pid[%d]\n", VER,
		getpid ());
      printf ("   REPORT ANY BUGS TO dem <vortex@qconline.com>\n");
      printf ("\n\n");
      
#else	
	printf ("   Welcome to demcd v%s running on pid[%d]\n", VER,
		getpid ());
      printf ("   REPORT ANY BUGS TO dem <vortex@qconline.com>\n");
      printf ("/-------------------------------------------------\\\n");
      printf ("\t\t     _ ----- _\n");
      printf ("\t\t  _-~         ~-_\n");
      printf ("\t\t /               \\\n");
      printf ("\t\t;      /---\\      ;\n");
      printf ("\t\t|      \\---/      |\n");
      printf ("\t\t|                 |\n");
      printf ("\t\t \\               /\n ");
      printf ("\t\t  ~-_         _-`\n");
      printf ("\t\t     ~ ----- ~\n");
      printf ("/------------------------------------------------\\\n");
      printf (" Compiled on %s        \n", DATE);
      printf (" On a %s           \n", MACHINE);
      printf (" Distributed under the GNU General Public License\n");
      printf (" See COPYING for further details                 \n");
      printf ("\\------------------------------------------------/\n");
#endif	
    }
return 0;
}
int 
     execute_line (line, ddcd)  char *
       line;
       DCD *ddcd;

{
  register int i;
  COMMAND * command;
  char *word;
  
    /* Isolate the command word. */ 
    i = 0;
  while (line[i] && whitespace (line[i]))
    i++;
  word = line + i;
  while (line[i] && !whitespace (line[i]))
    i++;
  if (line[i])
    line[i++] = '\0';
  command = find_command (word);
  if (!command)
    
    {
      if (fmistake (buf, test, 4, 1) == 1)
	
	{
	  execute_line (test, ddcd);
	  return 0;
	}
      
      else if (fmistake (buf, test, 3, 1) == 1)
	
	{
	  execute_line (test, ddcd);
	  return 0;
	}
      
      else if (fmistake (buf, test, 4, 0) == 1)
	
	{
	  execute_line (test, ddcd);
	  return 0;
	}
      
      else if (fmistake (buf, test, 3, 0) == 1)
	
	{
	  execute_line (test, ddcd);
	  return 0;
	}
      
      else if (fmistake (buf, test, 2, 1) == 1)
	
	{
	  execute_line (test, ddcd);
	  return 0;
	}
      
      else if (fmistake (buf, test, 2, 0) == 1)
	
	{
	  execute_line (test, ddcd);
	  return 0;
	}
      
      else
	{
	  Derr (buf);
	  return 0;
	}
      return 0;
    }
  
    /* Get argument to command, if any. */ 
    while (whitespace (line[i]))
    i++;
  word = line + i;
  
    /* Call the function. */ 
    return ((*(command->func)) (ddcd));
}

int prntrc()
{
   printf("cddbserver:      %s\n", CDDB_DEFAULT_HOSTNAME);
   printf("default-device:  %s\n", CD_DEV);
   printf("access:          %s\n", DEFAULTACCESS);
   if(llock!=1)
   printf("lock:            on\n");
   else
   printf("lock:            off\n");
   printf("type:            %d\n", DEFAULTTYPE);
 return 0;
}

char *
trkname_generator (text, state)
     char *text;
     int state;
{
  static int list_index, len;
  char *name;
  cd_stat(fd, &disc);

   if (!state)
    {
      list_index = 0;
      len = strlen (text);
    }
   while(list_index < disc.disc_total_tracks) {
         name = data.data_track[list_index++].track_name;

      if (strncasecmp (name, text, len) == 0)
	return (dupstr (name));
    }
  return ((char *) NULL);
}
